zn.define(function () {

    var STATE = {
        GOING: 1,
        PASSED: 2,
        ENDED: -1,
        CANCELED: -2,
        P_GOING: 100,
        P_PASS: 101,
        P_DENY: -101
    }

    return zn.Controller('my.init',{
        methods: {
            counts: {
                method: 'GET/POST',
                value: function (request, response, chain){
                    var _value = {};
                    this.beginTransaction()
                        .query("select apply count", function (sql, data){
                            return zn.sql.select({
                                table: 'zn_plugin_workflow_instance',
                                fields: 'count(id) as count',
                                where: [
                                    'parent_id=0',
                                    ' and zn_create_user=' + (request.getSessionValueByKey("id")||'-1')
                                ]
                            });
                        })
                        .query("select todo count", function (sql, data){
                            _value.applys = data[0].count;
                            return zn.sql.select({
                                table: 'zn_plugin_workflow_instance',
                                fields: 'count(id) as count',
                                where: [
                                    'parent_id=0',
                                    ' and state=' + STATE.GOING,
                                    ' and ' + zn.sql.rights()
                                ]
                            })
                        })
                        .query("select done count", function (sql, data){
                            _value.todos = data[0].count;
                            return zn.sql.select({
                                table: 'zn_plugin_workflow_instance',
                                fields: 'count(id) as count',
                                where: [
                                    'parent_id=0',
                                    " and locate(',"+request.getSessionValueByKey("id")+",', do_users)<>0"
                                ]
                            })
                        }, function (error, data){
                            if(error){
                                response.error(error);
                            }else {
                                _value.dones = data[0].count;
                                response.success(_value);
                            }
                        })
                        .commit();
                }
            }
        }
    });

});
