zn.define([
    '../service/WFIndexService.js'
], function (WFIndexService) {

    return zn.Controller('wfindex',{
        methods: {
            init: function (){
                this.indexService = new WFIndexService(this._store);
            },
            getCreateInfo: {
                method: 'GET/POST',
                value: function (request, response, chain){
                    this.collection('ZNPluginWorkflowIndex')
                        .select({
                            fields: ['id', 'zn_tree_pid', 'schema_type', 'zn_title','icon'],
                            order: {
                                zn_tree_order: 'asc'
                            },
                            where: [
                                zn.sql.rights()
                            ]
                        })
                        .then(function (data){
                            response.success(data);
                        }, function (err){
                            response.error(err);
                        });
                }
            },
            getSessionWFIndex: {
                method: 'GET/POST',
                value: function (request, response, chain){
                    this.collection('ZNPluginWorkflowIndex')
                        .select({
                            fields: ['id', 'zn_tree_pid', 'schema_type', 'zn_title','icon'],
                            order: {
                                zn_tree_order: 'asc'
                            },
                            where: [
                                zn.sql.rights()
                            ]
                        })
                        .then(function (data){
                            response.success(data);
                        }, function (err){
                            response.error(err);
                        });
                }
            },
            getIndexForm: {
                method: 'GET/POST',
                validate: true,
                argv: {
                    indexId: null
                },
                value: function (request, response, chain){
                    var _indexId = request.getValue('indexId');
                    this.beginTransaction()
                        .query('select table fields', function (sql, rows){
                            return zn.sql.select({
                                table: 'zn_plugin_workflow_index_table',
                                where: {
                                    index_id: _indexId
                                }
                            }) + zn.sql.select({
                                table: 'zn_plugin_workflow_index_table_field',
                                where: "index_id=" + _indexId,
                                order: {
                                    field_order: 'asc'
                                }
                            });
                        }, function (err, rows){
                            if(err){
                                response.error(err);
                            }else {
                                response.success(rows);
                            }
                        }).commit();
                }
            },
            getIndexSchema: {
                method: 'GET/POST',
                argv: {
                    indexId: null
                },
                value: function (request, response, chain){
                    this.beginTransaction()
                        .query('select wfindex schema', function (){
                            return "select * from zn_plugin_workflow_index where id={0};select * from zn_plugin_workflow_schema where index_id={0};".format(request.getInt('indexId'));
                        }, function (err, rows){
                            if(err){
                                response.error(err);
                            }else {
                                var _data = {};
                                _data.info = rows[0][0];
                                _data.info.json_schema = JSON.parse(_data.info.json_schema||'{"nodes":[],"links":[]}');
                                _data.schemas = rows[1];
                                response.success(_data);
                            }
                        }).commit();
                }
            },
            toDefinition: {
                method: 'GET/POST',
                argv: {
                    indexId: null
                },
                value: function (request, response, chain){
                    this.indexService
                        .toDefinition(request.getInt('indexId'))
                        .then(function (rows){
                            response.success(rows);
                        }, function (err){
                            response.error(err);
                        });
                }
            },
            createInstance: {
                method: 'GET/POST',
                argv: {
                    indexId: null,
                    base: null,
                    data: null
                },
                value: function (request, response, chain){
                    this.indexService
                        .createInstance(request.getInt('indexId'), request.getValue('base'), request.getValue('data'))
                        .then(function (rows){
                            response.success(rows);
                        }, function (err){
                            response.error(err);
                        });
                }
            }
        }
    });

});
