set global log_bin_trust_function_creators = 1;
----
DROP FUNCTION IF EXISTS zn_plugin_workflow_convert_index;
CREATE FUNCTION zn_plugin_workflow_convert_index($id int(11))
RETURNS VARCHAR(50)
BEGIN
DECLARE _temp varchar(50);
select zn_title INTO _temp from zn_plugin_workflow_index where id=$id;
RETURN _temp;
END
----
DROP FUNCTION IF EXISTS zn_plugin_workflow_convert_schema;
CREATE FUNCTION zn_plugin_workflow_convert_schema($uuid varchar(50))
RETURNS VARCHAR(50)
BEGIN
DECLARE _temp varchar(50);
select zn_title INTO _temp from zn_plugin_workflow_schema where uuid=$uuid;
RETURN _temp;
END
----
DROP FUNCTION IF EXISTS zn_plugin_workflow_convert_instance;
CREATE FUNCTION zn_plugin_workflow_convert_instance($id int(11))
RETURNS VARCHAR(50)
BEGIN
DECLARE _temp varchar(50);
select zn_title INTO _temp from zn_plugin_workflow_instance where id=$id;
RETURN _temp;
END
----
DROP FUNCTION IF EXISTS zn_plugin_workflow_convert_instance_current_state;
CREATE FUNCTION zn_plugin_workflow_convert_instance_current_state($id int(11))
RETURNS VARCHAR(50)
BEGIN
DECLARE _temp varchar(50);
select zn_title INTO _temp from zn_plugin_workflow_instance where parent_id=$id and state=1;
RETURN _temp;
END
----
DROP FUNCTION IF EXISTS zn_plugin_workflow_convert_schemas;
CREATE FUNCTION zn_plugin_workflow_convert_schemas(_ids varchar(500))
RETURNS varchar(1000)
begin
	declare _seeds varchar(1000) default ',';
	declare _seed varchar(100) default '';
	declare _id varchar(50);
	declare _split int;
	declare _len int;
	set _len = char_length(_ids);

  	while _len > 1 do
		set _split = locate(',', _ids, 2);
		set _id = substring(_ids, 2, (_split - 2));
		set _ids = substring(_ids, _split, (_len - _split + 1));
		set _len = char_length(_ids);
		set _seed = '';

		select zn_title into _seed from zn_plugin_workflow_schema where uuid=_id;

		if char_length(_seed)>=1 then
			set _seeds = concat(_seeds, _seed, ',');
		end if;
  	end while;

	return _seeds;
end
