zn.define(function () {

    var model = zn.db.common.model;

    return zn.Model("zn_plugin_workflow_instance", {
        mixins: [
            model.Base,
            model.Rights
        ],
        properties: {
            code: {
                value: null,
                type: ['varchar', 50],
                default: ''
            },
            form_id: {
                value: null,
                type: ['int', 11],
                default: 0
            },
            parent_id: {
                value: null,
                type: ['int', 11],
                default: 0
            },
            parent_instance_id: {
                value: null,
                type: ['int', 11],
                default: 0
            },
            sub_instance_id: {
                value: null,
                type: ['int', 11],
                default: 0
            },
            index_id: {
                value: null,
                type: ['int', 11],
                convert: "zn_plugin_workflow_convert_index({})",
                default: 0
            },
            schema_id: {
                value: null,
                type: ['int', 11],
                default: 0
            },
            schema_uuid: {
                value: null,
                type: ['varchar', 100],
                convert: 'zn_plugin_workflow_convert_schema({})',
                default: ''
            },
            previous: {
                value: null,
                type: ['int', 11],
                convert: 'zn_plugin_workflow_convert_instance({})',
                default: 0
            },
            next: {
                value: null,
                type: ['int', 11],
                convert: 'zn_plugin_workflow_convert_instance({})',
                default: 0
            },
            previous_schemas: {
                value: null,
                type: ['varchar', 200],
                convert: 'zn_plugin_workflow_convert_schemas({})',
                default: ''
            },
            next_schemas: {
                value: null,
                type: ['varchar', 200],
                convert: 'zn_plugin_workflow_convert_schemas({})',
                default: ''
            },
            type: {
                value: null,
                type: ['varchar', 10],
                default: ''
            },
            do_users: {
                value: null,
                type: ['varchar', 250],
                convert: 'zn_plugin_admin_convert_users({})',
                default: ','
            },
            rights_logic: {
                value: null,
                type: ['varchar', 100],
                default: ''
            },
            closed: {
                value: null,
                type: ['int', 11],
                default: 0
            },
            state: {
                value: null,
                type: ['int', 11],
                default: 1
            },
            owners: {
                value: null,
                type: ['varchar', 2000],
                default: ','
            },
            url: {
                value: null,
                type: ['varchar', 100],
                default: ''
            },
            icon: {
                value: null,
                type: ['varchar', 20],
                default: ''
            },
            attrs: {
                value: null,
                type: ['varchar', 3000],
                default: ""
            },
            files: {
                value: null,
                type: ['varchar', 5000],
                default: ","
            },
            schema_form_data: {
                value: null,
                type: ['varchar', 5000],
                default: ""
            }
        }
    });

})
