"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require('./CreateInstance.less');

var React = require('react');

var DeputyTable = React.createClass({
  displayName: "DeputyTable",
  getInitialState: function getInitialState() {
    return {
      data: this.props.deputy.data || [],
      size: 0,
      datas: {},
      requiredFields: [],
      notExists: []
    };
  },
  componentDidMount: function componentDidMount() {
    this.__initValidateDataSource();
  },
  __initValidateDataSource: function __initValidateDataSource() {
    var _fields = this.props.deputy.fields,
        _data = null,
        _self = this;

    _fields.forEach(function (field, index) {
      if (field.required) {
        this.state.requiredFields.push(field.title);

        if (field.data) {
          if (field.data._method) {
            (function (name) {
              field.data.exec().then(function (data) {
                if (data.status == 200) {
                  _self.state.datas[name] = data.result.map(function (item) {
                    return item.value;
                  });
                }
              });
            })(field.name);
          } else {
            this.state.datas[field.name] = field.data;
          }
        } else {
          this.state.datas[field.name] = true;
        }
      }
    }.bind(this));

    this.forceUpdate();
  },
  __onChange: function __onChange(files) {
    var _file = files[0];

    if (_file.name.indexOf('xls') == -1) {
      return (zn.notification.error || window.alert).call(null, '文件[' + _file.name + ']不是 xlsx / xls 类型'), false;
    }
  },
  __onComplete: function __onComplete(data, uploader) {
    if (this.refs.checkbox.getValue()) {
      this.state.data = this.state.data.concat(data[0].values);
    } else {
      this.state.data = data[0].values;
    }

    var _validate = this.props.onValidate && this.props.onValidate(this.state.data);

    if (_validate) {
      this.state.data = _validate;
    }

    if (_validate === false) {
      return false;
    }

    this.state.size = this.state.data.length; //this.state.deputyTables[index].data = (this.state.deputyTables[index].data||[]).concat(data[0].values);

    this.forceUpdate();
    this.props.onComplete && this.props.onComplete(data, uploader);
  },
  __onError: function __onError(msg) {
    zn.notification.error('Import Error: ' + msg);
    this.props.onError && this.props.onError(msg);
  },
  getValue: function getValue() {
    if (this.state.notExists.length) {
      return zn.notification.error("导入数据中有红色无效数据"), false;
    }

    var _value = this.refs.edit_table.getValue();

    _value = _value.map(function (item) {
      for (var key in item) {
        if (!item[key]) {
          item[key] = null;
          delete item[key];
        }
      }

      return item;
    });
    return _value;
  },
  setValue: function setValue(data) {
    this.refs.edit_table.setValue(data);
  },
  __onTableRowStyleValidate: function __onTableRowStyleValidate(item, index, length) {
    var _keys = Object.keys(this.state.datas);

    this.state.notExists = [];

    for (var i = 0, _len = _keys.length; i < _len; i++) {
      var _values = this.state.datas[_keys[i]],
          _value = item[_keys[i]];

      switch (_typeof(_values)) {
        case 'string':
        case 'number':
          if (_values != _value) {
            this.state.notExists.push(item);
            return {
              backgroundColor: '#d9534f66'
            };
          }

          break;

        case 'boolean':
          if (!_value) {
            this.state.notExists.push(item);
            return {
              backgroundColor: '#d9534f66'
            };
          }

          break;

        case 'object':
          if (_values.indexOf(_value) == -1) {
            this.state.notExists.push(item);
            return {
              backgroundColor: '#d9534f66'
            };
          }

          break;

        default:
      }
    }
  },
  __onRowColumnChange: function __onRowColumnChange(row, column, value, data, props) {
    this.props.onRowColumnChange && this.props.onRowColumnChange(row, column, value, data, props);
    this.forceUpdate();
  },
  __onAddRow: function __onAddRow() {
    this.state.data.push({});
    this.forceUpdate();
  },
  render: function render() {
    var _this = this;

    var deputy = this.props.deputy;
    return React.createElement("div", {
      className: "deputys"
    }, React.createElement("div", {
      className: "title"
    }, React.createElement("span", null, deputy.zn_title), (this.props.deputyUploadEnabled || !!deputy.import_enabled) && React.createElement("div", {
      className: "btns"
    }, React.createElement("a", {
      className: "btn",
      href: zn.http.fixURL('/zn.plugin.workflow/wfindextable/exportTableExcelTemplate?tableId=' + deputy.id)
    }, React.createElement("i", {
      className: "icon fa fa-download zr-padding-3"
    }), React.createElement("span", null, "Excel\u6570\u636E\u6A21\u677F\u4E0B\u8F7D")), React.createElement(zn.react.AjaxUploader, {
      action: "/zn.plugin.workflow/wfindextable/importTableExcelData",
      hiddens: {
        tableId: deputy.id
      },
      onChange: this.__onChange,
      onError: this.__onError,
      onComplete: function onComplete(data, uploader) {
        return _this.__onComplete(data, uploader);
      },
      multipart: false
    }, React.createElement("div", {
      className: "btn"
    }, React.createElement("i", {
      className: "icon fa fa-upload zr-padding-3"
    }), React.createElement("span", null, "Excel\u8868\u683C\u5BFC\u5165"), !!this.state.size && React.createElement("span", {
      style: {
        color: 'red'
      }
    }, "\u3010\u5DF2\u5BFC\u5165 ", this.state.size, " \u6761\u3011"))), React.createElement(zn.react.Checkbox, {
      style: {
        alignItems: 'center'
      },
      ref: "checkbox",
      text: "\u8FFD\u52A0\u6A21\u5F0F"
    }))), React.createElement("div", {
      className: "table"
    }, React.createElement(zn.react.EditableTable, {
      onRowColumnChange: this.__onRowColumnChange,
      rowStyleValidate: this.__onTableRowStyleValidate,
      ref: "edit_table",
      headers: deputy.fields,
      data: this.state.data
    })), !!this.state.requiredFields.length && React.createElement("div", {
      className: "tips"
    }, React.createElement("i", {
      className: "fa fa-info zr-padding-5"
    }, "\u63D0\u793A\uFF1A"), this.state.requiredFields.map(function (value) {
      return React.createElement("span", {
        style: {
          color: 'red',
          padding: 5
        }
      }, value);
    }), React.createElement("span", null, "\u662F\u5FC5\u586B\u8F93\u5165\u5B57\u6BB5")));
  }
});
module.exports = React.createClass({
  displayName: "exports",
  getDefaultProps: function getDefaultProps() {
    return {
      deputyUploadEnabled: false
    };
  },
  getInitialState: function getInitialState() {
    return {
      indexId: null,
      primaryTable: null,
      deputyTables: [],
      baseFormItems: [{
        title: '说明',
        name: 'zn_note',
        type: 'Textarea'
      }]
    };
  },
  componentDidMount: function componentDidMount() {
    this.__loadInfo();
  },
  componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
    if (nextProps.id != this.props.id) {
      this.__loadInfo(nextProps.id);
    }
  },
  __parseData: function __parseData(data) {
    var _tables = data[0],
        _fields = data[1],
        _table_fields = {};
    this.state.primaryTable = null;
    this.state.deputyTables = [];
    this.state.indexId = this.props.id;

    _fields.forEach(function (field) {
      if (!_table_fields[field.table_id]) {
        _table_fields[field.table_id] = [];
      }

      if (field.attrs) {
        field.attrs = JSON.parse(field.attrs);
      }

      if (field.props) {
        zn.extend(field, JSON.parse(field.props));
      } //field.value = field.default_value || field.field_default;


      field.data = this.__parseFieldData(field.data);

      _table_fields[field.table_id].push(field);
    }.bind(this));

    _tables.forEach(function (table) {
      table.fields = _table_fields[table.id] || [];
      table.data = table.data || [];

      if (table.parent_id) {
        if (table.is_input) {
          this.state.deputyTables.push(table);
        }
      } else {
        this.state.primaryTable = table;
      }
    }.bind(this));

    if (this.props.data && this.props.data.length) {
      this.props.data.forEach(function (items, index) {
        this.state.deputyTables[index].data = items;
      }.bind(this));
    }

    this.forceUpdate();
  },
  __parseFieldData: function __parseFieldData(data) {
    if (!data) {
      return data;
    }

    if (data.indexOf('javascript:') == 0) {
      return eval(data);
    } else if (data.indexOf('json:')) {
      return JSON.parse(data.substring(5));
    }

    return data;
  },
  __loadInfo: function __loadInfo(id) {
    var _id = id || this.props.id;

    if (_id) {
      zn.http.post('/zn.plugin.workflow/wfindex/getIndexForm', {
        indexId: _id
      }).then(function (data) {
        if (data.status == 200) {
          this.__parseData(data.result);
        } else {
          zn.notification.error(data.result);

          if (data.status == 401) {
            zn.react.session.doHome();
          }
        }
      }.bind(this), function () {
        zn.notification.error('加载失败');
      }.bind(this));
    }
  },
  __next: function __next() {
    zn.preloader.open({
      title: '加载数据...'
    });
    zn.http.post('/zn.plugin.workflow/wfinstance/next', {
      instanceId: 10,
      nextSchemaUUID: '77C31600-353A-4A9D-B15E-25B3D13C0794'
    }).then(function (data) {
      if (data.status == 200) {
        this.setState(data);
      } else {
        zn.toast.error(data.result);
      }

      zn.preloader.close();
    }.bind(this), function () {
      zn.toast.error('加载失败');
      zn.preloader.close();
    });
  },
  getSubmitValue: function getSubmitValue() {
    var _values = {},
        _value = null;

    for (var key in this.refs) {
      if (this.refs[key].validate) {
        _value = this.refs[key].validate(function (value, formitem) {
          if (formitem.props.required && !value) {
            return false;
          }
        });
      } else if (this.refs[key].getValue) {
        _value = this.refs[key].getValue();
      }

      if (!_value) {
        return false;
      } else {
        _values[key] = _value;
      }
    }

    return _values;
  },
  submit: function submit() {
    var _values = this.getSubmitValue();

    if (_values) {
      var _base = _values.base;
      _values.base = null;
      delete _values.base;
      zn.preloader.open({
        title: '正在创建中...'
      }); //zn.debug('data: ', _base, _values);

      zn.http.post('/zn.plugin.workflow/wfindex/createInstance', {
        indexId: this.state.indexId,
        base: _base,
        data: _values
      }).then(function (data) {
        if (data.status == 200) {
          zn.notification.success('流程创建成功');

          var _result = this.props.onCreateSuccess && this.props.onCreateSuccess(data.result);

          if (!this.props.onCreateSuccess || _result !== false) {
            zn.react.session.relativeJump('/znpluginworkflow.wfinstance?instanceId=' + data.result.instance_id);
          }
        } else {
          zn.notification.error('流程创建失败：' + data.result);
        }

        zn.preloader.close();
      }.bind(this), function () {
        var _result = this.props.onCreateError && this.props.onCreateError(data.result);

        if (_result !== false) {
          zn.notification.error('流程创建失败：调用服务器错误');
          zn.preloader.close();
        }
      });
    } else {
      zn.notification.error('表单数据验证失败');
    }
  },
  __onPrimaryFormChange: function __onPrimaryFormChange(value, input, form) {
    this.props.onPrimaryFormChange && this.props.onPrimaryFormChange(value, input, form);
  },
  render: function render() {
    if (!this.state.indexId) {
      return React.createElement(zn.react.DataLoader, {
        style: {
          padding: 20
        },
        loader: "timer",
        content: "\u6B63\u5728\u52A0\u8F7D\u4E2D..."
      });
    }

    return React.createElement("div", {
      className: zn.react.classname("zn-plugin-workflow-create-instance", this.props.className),
      style: this.props.style
    }, React.createElement(zn.react.Group, {
      title: "\u8868\u5355\u4FE1\u606F"
    }, this.state.primaryTable && React.createElement(zn.react.Form, {
      onChange: this.__onPrimaryFormChange,
      value: this.props.baseValue || {},
      ref: this.state.primaryTable.table_name,
      buttons: [],
      items: this.state.primaryTable.fields
    }), this.state.deputyTables.map(function (deputy, index) {
      deputy.width = null;
      delete deputy.width;
      return React.createElement(DeputyTable, _extends({}, this.props, {
        onValidate: this.props.onDeputyValidate,
        deputy: deputy,
        ref: deputy.table_name
      }));
    }.bind(this))), React.createElement(zn.react.Group, {
      title: "\u6D41\u7A0B\u4FE1\u606F"
    }, React.createElement(zn.react.Form, {
      ref: "base",
      buttons: [],
      items: this.state.baseFormItems
    })), React.createElement("div", {
      style: {
        paddingTop: 10,
        overflow: 'hidden'
      }
    }, React.createElement(zn.react.Button, {
      onClick: this.submit,
      float: "right",
      text: "\u521B\u5EFA\u6D41\u7A0B\u5355\u636E",
      icon: "fa-plus",
      style: {
        width: 120
      }
    })));
  }
});