"use strict";

require('./WFInstance.less');

var React = require('react');

var BaseInfo = require('./instance/BaseInfo');

var FlowStep = require('./instance/FlowStep');

var FlowTableInfo = require('./instance/FlowTableInfo');

module.exports = React.createClass({
  displayName: "exports",
  getInitialState: function getInitialState() {
    return {
      base: null,
      current: null,
      data: null,
      table_fields: [],
      table_data: []
    };
  },
  componentDidMount: function componentDidMount() {
    this.__loadInfo();
  },
  componentDidUpdate: function componentDidUpdate(prevProps, prevState) {
    if (prevProps.instanceId != this.props.instanceId) {
      this.__loadInfo();
    }
  },
  __loadInfo: function __loadInfo() {
    if (this.props.instanceId) {
      zn.preloader.open({
        title: '加载数据...'
      });
      zn.http.post('/zn.plugin.workflow/wfinstance/getInstance', {
        instanceId: this.props.instanceId
      }).then(function (data) {
        if (data.status == 200) {
          this.setState(data.result);
        } else {
          zn.notification.error(data.result);

          if (data.status == 401) {
            zn.react.session.doHome();
          }
        }

        zn.preloader.close();
      }.bind(this), function () {
        zn.notification.error('加载失败');
        zn.preloader.close();
      });
    }
  },
  __cancel: function __cancel() {
    zn.confirm('确定取消流程吗？', '提示', function () {
      zn.preloader.open({
        title: '流程取消中...'
      });
      zn.http.post('/zn.plugin.workflow/wfinstance/cancel', {
        instanceId: this.state.base.id
      }).then(function (data) {
        if (data.status == 200) {
          this.__loadInfo();
        } else {
          zn.notification.error(data.result);
        }

        zn.preloader.close();
      }.bind(this), function () {
        zn.notification.error('取消失败');
        zn.preloader.close();
      });
    }.bind(this));
  },
  __remove: function __remove() {
    zn.confirm('删除流程将删除流程相关的所有数据, 确定删除吗？', '提示', function () {
      zn.preloader.open({
        title: '流程删除中...'
      });
      zn.http.post('/zn.plugin.workflow/wfinstance/remove', {
        instanceId: this.state.base.id
      }).then(function (data) {
        if (data.status == 200) {
          zn.notification.success('删除成功');
          zn.react.session.back();
        } else {
          zn.notification.error(data.result);
        }

        zn.preloader.close();
      }.bind(this), function () {
        zn.notification.error('删除失败');
        zn.preloader.close();
      });
    }.bind(this));
  },
  __start: function __start() {
    zn.confirm('确定打开流程吗？', '提示', function () {
      zn.preloader.open({
        title: '流程打开中...'
      });
      zn.http.post('/zn.plugin.workflow/wfinstance/start', {
        instanceId: this.state.base.id
      }).then(function (data) {
        if (data.status == 200) {
          this.__loadInfo();
        } else {
          zn.notification.error(data.result);
        }

        zn.preloader.close();
      }.bind(this), function () {
        zn.notification.error('打开失败');
        zn.preloader.close();
      });
    }.bind(this));
  },
  __renderAction: function __renderAction() {
    if (this.state.base.isCreator) {
      return React.createElement("div", {
        style: {
          display: 'inline-block'
        }
      }, this.state.base.closed ? React.createElement("a", {
        style: {
          color: '#1289d8',
          marginLeft: 10,
          fontSize: 14
        },
        onClick: this.__start,
        href: "javascript:void(0);"
      }, "\u6253\u5F00") : React.createElement("a", {
        style: {
          color: '#f00',
          marginLeft: 10,
          fontSize: 14
        },
        onClick: this.__cancel,
        href: "javascript:void(0);"
      }, "\u5173\u95ED"), this.state.base.state != -1 && React.createElement("a", {
        style: {
          color: '#f00',
          marginLeft: 10,
          fontSize: 14
        },
        onClick: this.__remove,
        href: "javascript:void(0);"
      }, "\u5220\u9664"));
    } else {
      return null;
    }
  },
  render: function render() {
    if (!this.state.current || !this.state.base) {
      return React.createElement("div", {
        className: "zn-plugin-workflow-instance"
      }, React.createElement("div", {
        className: "not-exist"
      }, "\u6D41\u7A0B\u5B9E\u4F8BId(", this.props.instanceId, ")\u4E0D\u5B58\u5728, \u8BF7\u6838\u5B9E\u540E\u518D\u8BD5!"));
    }

    if (this.state.base.zn_rights_enabled && !this.state.base.doRights && !this.state.base.doObserveRights) {
      return React.createElement("div", {
        className: "zn-plugin-workflow-instance"
      }, React.createElement("div", {
        className: "not-exist"
      }, "\u6B64\u6D41\u7A0B\u60A8\u6682\u65E0\u3010\u6D4F\u89C8\u3011\u53CA\u3010\u64CD\u4F5C\u3011\u6743\u9650, \u8BF7\u8054\u7CFB\u7CFB\u7EDF\u7BA1\u7406\u5458\u540E\u518D\u91CD\u8BD5!"));
    }

    return React.createElement("div", {
      className: "zn-plugin-workflow-instance closed-" + this.state.base.closed
    }, React.createElement("div", {
      className: "index-title"
    }, React.createElement("span", null, this.state.base.index_id_convert), React.createElement("span", null, " ", this.state.base.code), this.__renderAction()), React.createElement("div", {
      style: {
        display: 'flex',
        justifyContent: 'space-between',
        padding: '0px 3px'
      }
    }, React.createElement("div", null, React.createElement("span", null, "\u7533\u8BF7\u4EBA\uFF1A"), React.createElement("span", {
      style: {
        fontWeight: 200
      }
    }, this.state.base.zn_create_user_convert)), React.createElement("div", null, React.createElement("span", null, "\u7533\u8BF7\u65F6\u95F4\uFF1A"), React.createElement("span", {
      style: {
        fontWeight: 200
      }
    }, this.state.base.zn_create_time))), this.state.table_fields && !!this.state.table_fields.length && React.createElement(FlowTableInfo, {
      fields: this.state.table_fields,
      data: this.state.table_data
    }), this.state.base && !this.state.base.closed && !!this.state.base.doRights && this.state.current && React.createElement(BaseInfo, {
      value: this.props.value,
      onNextSuccess: this.__loadInfo,
      base: this.state.base,
      current: this.state.current
    }), this.state.data && this.state.current && React.createElement(FlowStep, {
      instanceId: this.props.instanceId,
      data: this.state.data,
      current: this.state.current,
      onRemarkSuccess: this.__loadInfo
    }), this.state.base.zn_note && React.createElement("div", {
      className: "zn-plugin-workflow-panel"
    }, React.createElement("div", {
      className: "title"
    }, "\u6D41\u7A0B\u5907\u6CE8"), React.createElement("div", {
      className: "content"
    }, React.createElement("div", {
      style: {
        minHeight: 60
      }
    }, this.state.base.zn_note))));
  }
});