"use strict";

var React = require('react');

var CreateInstance = require('./CreateInstance');

module.exports = React.createClass({
  displayName: "exports",
  getDefaultProps: function getDefaultProps() {
    return {
      model: 'ZNPluginWorkflowInstance'
    };
  },
  getInitialState: function getInitialState() {
    return {
      data: zn.store.post('/zn.plugin.workflow/wfinstance/getInstances', {
        index_id: this.props.indexId
      }),
      items: [{
        title: '模块',
        name: 'index_id_convert',
        width: 80
      }, {
        title: '单号',
        name: 'code',
        width: 150
      }, {
        title: '状态',
        name: 'state',
        width: 80
      }, {
        title: '当前节点',
        name: 'current_state',
        width: 120
      }, {
        title: '申请人',
        name: 'zn_create_user_convert',
        width: 100
      }, {
        title: '申请时间',
        name: 'zn_create_time',
        width: 130
      }, {
        title: '最近一次操作时间',
        name: 'zn_modify_time',
        width: 130
      }, {
        title: '说明',
        name: 'zn_note'
      }],
      toolbarItems: [{
        text: '创建实例',
        name: 'wfinstance.create',
        icon: 'fa-plus',
        style: {
          marginRight: 5
        }
      }, {
        text: '删除实例',
        name: 'wfinstance.delete',
        status: 'danger',
        icon: 'fa-remove',
        style: {
          marginRight: 5
        }
      }]
    };
  },
  componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
    if (nextProps.indexId) {
      this.state.data.extend({
        index_id: nextProps.indexId
      }).refresh();
    }
  },
  __doSuccess: function __doSuccess() {
    this.state.data.refresh();
  },
  __createInstance: function __createInstance() {
    zn.dialog({
      title: '创建流程实例',
      content: React.createElement(CreateInstance, {
        id: this.props.indexId
      })
    });
  },
  __removeItems: function __removeItems() {
    var _self = this,
        _values = this.refs.table.getValue();

    if (_values && _values.length) {
      zn.confirm('确认删除这' + _values.length + '个用户吗？', '提示', function () {
        zn.http.post('/zn.plugin.admin/model/delete', {
          model: this.props.model,
          where: "id in (" + _values.join(',') + ")"
        }).then(function (data) {
          if (data.status == 200) {
            zn.toast.success('删除成功');

            _self.state.data.refresh();
          } else {
            zn.toast.error('删除失败: ' + data.result);
          }
        }, function (data) {
          zn.toast.error('服务器错误：删除失败');
        });
      }.bind(this));
    } else {
      zn.toast.warning('请先选择要删除的用户');
    }
  },
  __onToolbarClick: function __onToolbarClick(item) {
    switch (item.name) {
      case 'wfinstance.create':
        this.__createInstance();

        break;

      case 'wfinstance.delete':
        this.__removeItems();

        break;
    }
  },
  __onTableColumnRender: function __onTableColumnRender(rowIndex, columnIndex, data, item, value) {
    switch (columnIndex) {
      case 2:
        return React.createElement("a", {
          href: '#' + zn.react.session.fixPath('/znpluginworkflow.wfinstance') + '?instanceId=' + data.id
        }, value);

      case 3:
        switch (value) {
          case 1:
            return React.createElement("span", {
              className: "status",
              style: {
                backgroundColor: '#f0ad4e'
              }
            }, "\u5F85\u5904\u7406");

          case -1:
            return React.createElement("span", {
              className: "status",
              style: {
                backgroundColor: '#6def55'
              }
            }, "\u5DF2\u7ED3\u675F");

          case -2:
            return React.createElement("span", {
              className: "status",
              style: {
                backgroundColor: '#dad8d8'
              }
            }, "\u5DF2\u53D6\u6D88");

          case 2:
            return React.createElement("span", {
              className: "status",
              style: {
                backgroundColor: '#0d8c06'
              }
            }, "\u5DF2\u5BA1\u6838");
        }

        break;
    }
  },
  render: function render() {
    return React.createElement(zn.react.Page, {
      className: "zn-plugin-workflow-wf-my",
      title: "\u6D41\u7A0B\u5217\u8868",
      toolbarItems: this.state.toolbarItems,
      onToolbarClick: this.__onToolbarClick
    }, React.createElement(zn.react.PagerView, {
      ref: "table",
      view: "Table",
      enableFilter: true,
      checkbox: 50,
      showHeader: true,
      columnRender: this.__onTableColumnRender,
      data: this.state.data,
      items: this.state.items
    }));
  }
});