"use strict";

require('./BaseInfo.less');

var React = require('react');

module.exports = React.createClass({
  displayName: "exports",
  getInitialState: function getInitialState() {
    return {
      nextSchemaUUID: null,
      formItems: [{
        title: '备注',
        name: 'zn_note',
        type: 'Textarea'
      }, {
        title: '附件',
        name: 'files',
        type: 'FileUploader'
      }]
    };
  },
  componentDidUpdate: function componentDidUpdate(prevProps, prevState) {
    this.refs.base_form.reset();
  },
  __cancel: function __cancel() {
    zn.confirm('确定取消流程吗？', '提示', function () {
      zn.preloader.open({
        title: '取消中...'
      });
      zn.http.post('/zn.plugin.workflow/wfinstance/cancel', {
        instanceId: this.props.base.id
      }).then(function (data) {
        if (data.status == 200) {
          this.setState(data);
        } else {
          zn.notification.error(data.result);
        }

        zn.preloader.close();
      }.bind(this), function () {
        zn.notification.error('取消失败');
        zn.preloader.close();
      });
    }.bind(this));
  },
  __onCancel: function __onCancel() {
    if (!this.state.nextSchemaUUID) {
      return zn.notification.warning('流程已结束!'), false;
    }

    if (this.refs.base_form) {
      var _temp = this.refs.base_form.getValue();

      if (_temp) {
        zn.confirm('驳回该流程吗？', '提示', function () {
          zn.preloader.open({
            title: '提交中...'
          });
          zn.http.post('/zn.plugin.workflow/wfinstance/deny', {
            instanceId: this.props.base.id,
            options: _temp
          }).then(function (data) {
            if (data.status == 200) {
              zn.notification.success('提交成功');
              this.state.nextSchemaUUID = null;
              this.props.onNextSuccess && this.props.onNextSuccess();
            } else {
              zn.notification.error(data.result);
            }

            zn.preloader.close();
          }.bind(this), function () {
            zn.notification.error('提交失败');
            zn.preloader.close();
          });
        }.bind(this));
      } else {
        return zn.notification.warning('表单还未填写完成!'), false;
      }
    }

    return false;
  },
  __onFormSubmitBefore: function __onFormSubmitBefore(value) {
    if (!this.state.nextSchemaUUID) {
      return zn.notification.warning('流程已结束!'), false;
    }

    if (this.refs.schema_form) {
      var _temp = this.refs.schema_form.getValue();

      if (_temp) {
        value.schema_form_data = JSON.stringify(_temp);
      } else {
        return zn.notification.warning('自定义表单还未填写完成!'), false;
      }
    }

    zn.confirm('确认该流程吗？', '提示', function () {
      zn.preloader.open({
        title: '提交中...'
      });
      zn.http.post('/zn.plugin.workflow/wfinstance/next', {
        instanceId: this.props.base.id,
        nextSchemaUUID: this.state.nextSchemaUUID,
        options: value
      }).then(function (data) {
        if (data.status == 200) {
          zn.notification.success('确认成功');
          this.state.nextSchemaUUID = null;
          this.props.onNextSuccess && this.props.onNextSuccess();
        } else {
          zn.notification.error(data.result);
        }

        zn.preloader.close();
      }.bind(this), function () {
        zn.notification.error('确认失败');
        zn.preloader.close();
      });
    }.bind(this));
    return false;
  },
  render: function render() {
    var _next_ids = this.props.current.next_schemas.split(','),
        _next_texts = this.props.current.next_schemas_convert.split(',');

    if (!_next_ids.filter(function (id) {
      if (id) {
        return true;
      }
    }).length) {
      return null;
    }

    return React.createElement("div", {
      className: "zn-plugin-workflow-instance-base-info zn-plugin-workflow-panel"
    }, React.createElement("div", {
      className: "title"
    }, React.createElement("span", null, "\u4E0B\u4E00\u6B65(Next Step)")), React.createElement("div", {
      className: "content"
    }, React.createElement("ul", {
      className: "next-steps"
    }, _next_ids.map(function (value, index) {
      var _this = this;

      if (!value) {
        return null;
      }

      if (!this.state.nextSchemaUUID) {
        this.state.nextSchemaUUID = value;
      }

      return React.createElement("li", {
        onClick: function onClick() {
          return _this.setState({
            nextSchemaUUID: value
          });
        },
        className: this.state.nextSchemaUUID == value ? 'selected' : ''
      }, _next_texts[index]);
    }.bind(this))), this.props.current.schema_fields && !!this.props.current.schema_fields.length && React.createElement(zn.react.Group, {
      title: "\u81EA\u5B9A\u4E49\u8868\u5355"
    }, React.createElement(zn.react.Form, {
      key: "wf_form_" + new Date().getTime(),
      ref: "schema_form",
      valueKey: "title",
      items: this.props.current.schema_fields,
      buttons: []
    })), this.props.base.closed == 0 && this.props.base.state == 1 && this.state.nextSchemaUUID && React.createElement(zn.react.Group, {
      title: "\u57FA\u7840\u8868\u5355"
    }, React.createElement(zn.react.Form, {
      key: "wf_form_" + new Date().getTime(),
      ref: "base_form",
      items: this.state.formItems,
      onSubmitBefore: this.__onFormSubmitBefore,
      buttons: [{
        text: '拒绝(驳回)',
        icon: 'fa-microphone-slash',
        onClick: this.__onCancel,
        status: 'danger'
      }, {
        text: '确认通过',
        icon: 'fa-check-circle-o',
        type: 'submit',
        status: 'primary'
      }]
    }))));
  }
});