"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

require('./WFApply.less');

var React = require('react');

var CreateInstance = require('../component/CreateInstance.js');

module.exports = React.createClass({
  displayName: "exports",
  getInitialState: function getInitialState() {
    return {
      data: []
    };
  },
  componentDidMount: function componentDidMount() {
    this.__loadWFIndex();
  },
  __parseData: function __parseData(data) {
    var _root = [],
        _root_ids = {},
        _childs = [];
    data.forEach(function (item) {
      if (item.schema_type == 'category') {
        item.children = [];

        _root.push(item);

        _root_ids[item.id] = item;
      } else {
        _childs.push(item);
      }
    });

    _childs.forEach(function (child) {
      if (child.zn_tree_pid && _root_ids[child.zn_tree_pid]) {
        _root_ids[child.zn_tree_pid].children.push(child);
      } else {}
    });

    return _root;
  },
  __loadWFIndex: function __loadWFIndex() {
    zn.http.post('/zn.plugin.workflow/wfindex/getSessionWFIndex').then(function (data) {
      if (data.status == 200) {
        this.setState({
          data: this.__parseData(data.result)
        });
      } else {
        zn.notification.error(data.result);
      }
    }.bind(this), function () {
      zn.notification.error('服务器错误');
    });
  },
  __onCreateSuccess: function __onCreateSuccess(instanceId) {
    zn.react.session.relativeJump('/znpluginworkflow.wfinstance?instanceId=' + instanceId);
  },
  __createInstance: function __createInstance(index) {
    zn.dialog({
      title: '创建【' + index.zn_title + '】流程实例',
      content: React.createElement(CreateInstance, _extends({}, index, {
        onCreateSuccess: this.__onCreateSuccess
      }))
    });
  },
  render: function render() {
    var _self = this;

    return React.createElement(zn.react.Page, {
      className: "zn-plugin-workflow-wf-apply",
      title: "\u6D41\u7A0B\u7533\u8BF7"
    }, React.createElement("ul", {
      className: "indexs"
    }, this.state.data.map(function (item) {
      return React.createElement("li", {
        className: "index"
      }, React.createElement("div", {
        className: "header"
      }, item.icon && React.createElement("i", {
        className: "fa zr-padding-5 " + item.icon
      }), React.createElement("span", null, item.zn_title + (item.children.length ? "( " + item.children.length + " )" : ""))), React.createElement("div", {
        className: "content"
      }, item.children.map(function (child) {
        return React.createElement("div", {
          className: "child"
        }, React.createElement("div", {
          className: "info"
        }, child.icon && React.createElement("i", {
          className: "fa zr-padding-5 " + child.icon
        }), React.createElement("span", null, child.zn_title)), React.createElement("div", {
          className: "btns"
        }, React.createElement("span", {
          className: "btn"
        }, "\u67E5\u770B\u5355\u636E"), React.createElement("span", {
          className: "btn",
          onClick: function onClick() {
            return _self.__createInstance(child);
          }
        }, React.createElement("i", {
          className: "fa fa-plus zr-padding-3"
        }), "\u53D1\u8D77\u6D41\u7A0B")));
      })));
    })));
  }
});