"use strict";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var React = require('react');

var WFSchemaDesigner = require('../component/WFSchemaDesigner.js');

var WFFormDesigner = require('../component/WFFormDesigner.js');

var WFIndexDesigner = React.createClass({
  displayName: "WFIndexDesigner",
  getInitialState: function getInitialState() {
    return {
      currIndex: 0
    };
  },
  render: function render() {
    var _this = this;

    return React.createElement("div", {
      className: "zr-flex-layout"
    }, React.createElement(zn.react.ListView, {
      className: "layout-header zr-tab-ios",
      style: {
        margin: 5
      },
      selectMode: "radio",
      textKey: "text",
      valueKey: "index",
      onClick: function onClick(value) {
        return _this.setState({
          currIndex: value.item.index
        });
      },
      value: this.state.currIndex,
      data: [{
        index: 0,
        text: '流程定义',
        icon: 'fa-sitemap'
      }, {
        index: 1,
        text: '表单定义',
        icon: 'fa-server'
      }]
    }), React.createElement("div", {
      className: "layout-body"
    }, this.state.currIndex ? React.createElement(WFFormDesigner, {
      indexId: this.props.indexId
    }) : React.createElement(WFSchemaDesigner, {
      indexId: this.props.indexId
    })));
  }
});
module.exports = React.createClass({
  displayName: "exports",
  getDefaultProps: function getDefaultProps() {
    return {
      model: 'zn_plugin_workflow_index',
      pid: 0,
      title: '流程索引',
      menuId: 0,
      fields: [{
        title: '名称',
        type: 'Input',
        name: 'zn_title'
      }, {
        title: '类型',
        type: 'Radio',
        name: 'schema_type',
        value: 'category',
        data: [{
          text: '流程类别',
          value: 'category'
        }, {
          text: '流程定义',
          value: 'schema'
        }]
      }, {
        title: '图标',
        type: 'RichSelector',
        selector: zn.plugin.admin.FontAwesomeIcons,
        textRender: function textRender(text) {
          return React.createElement("i", {
            className: "fa " + text
          });
        },
        name: 'icon'
      }, {
        title: '是否启用权限',
        type: 'Radio',
        name: 'zn_rights_enabled',
        value: 0,
        data: [{
          text: '禁止',
          value: 0
        }, {
          text: '启用',
          value: 1
        }]
      }, {
        title: '权限用户',
        type: zn.plugin.admin.UserSelector,
        mulitable: true,
        name: 'zn_rights_users'
      }, {
        title: '权限角色',
        type: zn.plugin.admin.RoleSelector,
        name: 'zn_rights_roles'
      }, {
        title: '说明',
        type: 'Textarea',
        name: 'zn_note'
      }]
    };
  },
  __rightRender: function __rightRender(data) {
    if (data.data.schema_type == 'category') {
      return;
    }

    return React.createElement(WFIndexDesigner, {
      indexId: data.value
    });
  },
  __itemContentRender: function __itemContentRender(data, treeColumn, tree) {
    return React.createElement("span", null, data.schema_type == 'category' ? React.createElement("i", {
      "data-tooltip": "\u6D41\u7A0B\u7C7B\u522B",
      className: "fa fa-folder",
      style: {
        padding: 5
      }
    }) : React.createElement("i", _defineProperty({
      title: "\u6D41\u7A0B\u5B9A\u4E49",
      className: 'fa ' + (data.icon || 'fa-sitemap'),
      style: {
        padding: 5
      }
    }, "style", {
      padding: 5
    })), data.zn_title);
  },
  render: function render() {
    return React.createElement(zn.plugin.admin.TreeModelView, _extends({}, this.props, {
      rightRender: this.__rightRender,
      itemContentRender: this.__itemContentRender
    }));
  }
});