require('./CreateInstance.less');
var React = require('react');

var DeputyTable = React.createClass({
	getInitialState: function (){
		return {
			data: this.props.deputy.data || [],
			size: 0,
			datas: {},
			requiredFields: [],
			notExists: []
		}
	},
	componentDidMount: function (){
		this.__initValidateDataSource();
	},
	__initValidateDataSource: function (){
		var _fields = this.props.deputy.fields,
			_data = null,
			_self = this;
		_fields.forEach(function (field, index){
			if(field.required){
				this.state.requiredFields.push(field.title);
				if(field.data){
					if(field.data._method){
						(function (name){
							field.data.exec().then(function (data){
								if(data.status==200){
									_self.state.datas[name] = data.result.map((item)=>item.value);
								}
							});
						})(field.name);
					}else {
						this.state.datas[field.name] = field.data;
					}
				}else {
					this.state.datas[field.name] = true;
				}
			}
		}.bind(this));
		this.forceUpdate();
	},
	__onChange: function (files){
		var _file = files[0];
		if(_file.name.indexOf('xls')==-1){
			return (zn.notification.error || window.alert).call(null, '文件[' + _file.name + ']不是 xlsx / xls 类型'), false;
		}
	},
	__onComplete: function (data, uploader){
		if(this.refs.checkbox.getValue()){
			this.state.data = this.state.data.concat(data[0].values);
		}else {
			this.state.data = data[0].values;
		}
		var _validate = this.props.onValidate && this.props.onValidate(this.state.data);
		if(_validate){
			this.state.data = _validate;
		}
		if(_validate === false){
			return false;
		}

		this.state.size = this.state.data.length;
		//this.state.deputyTables[index].data = (this.state.deputyTables[index].data||[]).concat(data[0].values);

		this.forceUpdate();
		this.props.onComplete && this.props.onComplete(data, uploader);
	},
	__onError: function (msg){
		zn.notification.error('Import Error: ' + msg);
		this.props.onError && this.props.onError(msg);
	},
	getValue: function (){
		if(this.state.notExists.length){
			return zn.notification.error("导入数据中有红色无效数据"), false;
		}
		var _value = this.refs.edit_table.getValue();
		_value = _value.map(function (item){
			for(var key in item){
				if(!item[key]){
					item[key] = null;
					delete item[key];
				}
			}
			return item;
		});

		return _value;
	},
	setValue: function (data){
		this.refs.edit_table.setValue(data);
	},
	__onTableRowStyleValidate: function (item, index, length){
		var _keys = Object.keys(this.state.datas);
		this.state.notExists = [];
		for(var i = 0, _len = _keys.length; i < _len; i++){
			var _values = this.state.datas[_keys[i]],
				_value = item[_keys[i]];
			switch (typeof _values) {
				case 'string':
				case 'number':
					if(_values != _value){
						this.state.notExists.push(item);
						return { backgroundColor: '#d9534f66' };
					}
					break;
				case 'boolean':
					if(!_value){
						this.state.notExists.push(item);
						return { backgroundColor: '#d9534f66' };
					}
					break;
				case 'object':
					if(_values.indexOf(_value)==-1){
						this.state.notExists.push(item);
						return { backgroundColor: '#d9534f66' };
					}
					break;
				default:
			}
		}
	},
	__onRowColumnChange: function (row, column, value, data, props){
		this.props.onRowColumnChange && this.props.onRowColumnChange(row, column, value, data, props);
		this.forceUpdate();
	},
	__onAddRow: function (){
		this.state.data.push({});
		this.forceUpdate();
	},
	render: function (){
		var deputy = this.props.deputy;
		return (
			<div className="deputys">
				<div className="title">
					<span>{deputy.zn_title}</span>
					{
						(this.props.deputyUploadEnabled || !!deputy.import_enabled) && <div className="btns">
							{
								/*
								<a className="btn" onClick={this.__onAddRow} >
									<i className="icon fa fa-plus zr-padding-3" />
									<span>添加行</span>
								</a>
								*/
							}
							<a className="btn" href={zn.http.fixURL('/zn.plugin.workflow/wfindextable/exportTableExcelTemplate?tableId='+deputy.id)}>
								<i className="icon fa fa-download zr-padding-3" />
								<span>Excel数据模板下载</span>
							</a>
							<zn.react.AjaxUploader
								action="/zn.plugin.workflow/wfindextable/importTableExcelData"
								hiddens={{
									tableId: deputy.id
								}}
								onChange={this.__onChange}
								onError={this.__onError}
								onComplete={(data, uploader)=>this.__onComplete(data, uploader)}
								multipart={false} >
								<div className="btn">
									<i className="icon fa fa-upload zr-padding-3" />
									<span>Excel表格导入</span>
									{
										!!this.state.size && <span style={{color: 'red'}}>【已导入 {this.state.size} 条】</span>
									}
								</div>
							</zn.react.AjaxUploader>
							<zn.react.Checkbox style={{alignItems: 'center'}} ref="checkbox" text="追加模式" />
						</div>
					}
				</div>
				<div className="table">
					<zn.react.EditableTable onRowColumnChange={this.__onRowColumnChange} rowStyleValidate={this.__onTableRowStyleValidate} ref="edit_table" headers={deputy.fields} data={this.state.data} />
				</div>
				{
					!!this.state.requiredFields.length && <div className="tips">
						<i className="fa fa-info zr-padding-5" >提示：</i>
						{
							this.state.requiredFields.map(function (value){
								return <span style={{ color: 'red', padding: 5 }}>{value}</span>
							})
						}
						<span>是必填输入字段</span>
					</div>
				}
			</div>
		);
	}
});

module.exports = React.createClass({
	getDefaultProps: function () {
		return {
			deputyUploadEnabled: false
		};
	},
	getInitialState: function () {
		return {
			indexId: null,
			primaryTable: null,
			deputyTables: [],
			baseFormItems: [
				{ title: '说明', name: 'zn_note', type: 'Textarea' }
			]
		};
	},
	componentDidMount: function (){
		this.__loadInfo();
	},
	componentWillReceiveProps: function (nextProps){
		if(nextProps.id!=this.props.id){
			this.__loadInfo(nextProps.id);
		}
	},
	__parseData: function (data){
		var _tables = data[0],
		 	_fields = data[1],
			_table_fields = {};
		this.state.primaryTable = null;
		this.state.deputyTables = [];
		this.state.indexId = this.props.id;
		_fields.forEach(function (field){
			if(!_table_fields[field.table_id]){
				_table_fields[field.table_id] = [];
			}
			if(field.attrs){
				field.attrs = JSON.parse(field.attrs);
			}
			if(field.props){
				zn.extend(field, JSON.parse(field.props));
			}
			//field.value = field.default_value || field.field_default;
			field.data = this.__parseFieldData(field.data);
			_table_fields[field.table_id].push(field);
		}.bind(this));
		_tables.forEach(function (table){
			table.fields = _table_fields[table.id] || [];
			table.data = table.data || [];
			if(table.parent_id){
				if(table.is_input){
					this.state.deputyTables.push(table);
				}
			}else {
				this.state.primaryTable = table;
			}
		}.bind(this));

		if(this.props.data && this.props.data.length){
			this.props.data.forEach(function (items, index){
				this.state.deputyTables[index].data = items;
			}.bind(this));
		}
		this.forceUpdate();
	},
	__parseFieldData: function (data){
		if(!data){
			return data;
		}

		if(data.indexOf('javascript:') == 0){
			return eval(data);
		}else if(data.indexOf('json:')) {
			return JSON.parse(data.substring(5));
		}

		return data;
	},
	__loadInfo: function (id){
		var _id = id || this.props.id;
		if(_id){
			zn.http.post('/zn.plugin.workflow/wfindex/getIndexForm', {
				indexId: _id
			}).then(function (data){
				if(data.status==200){
					this.__parseData(data.result);
				}else {
					zn.notification.error(data.result);
					if(data.status==401){
						zn.react.session.doHome();
					}
				}
			}.bind(this), function (){
				zn.notification.error('加载失败');
			}.bind(this));
		}
	},
	__next: function (){
		zn.preloader.open({ title: '加载数据...' });
		zn.http.post('/zn.plugin.workflow/wfinstance/next', {
			instanceId: 10,
			nextSchemaUUID: '77C31600-353A-4A9D-B15E-25B3D13C0794'
		}).then(function (data){
			if(data.status==200){
				this.setState(data);
			}else {
				zn.toast.error(data.result);
			}
			zn.preloader.close();
		}.bind(this), function (){
			zn.toast.error('加载失败');
			zn.preloader.close();
		});
	},
	getSubmitValue: function (){
		var _values = {},
			_value = null;
		for(var key in this.refs){
			if(this.refs[key].validate){
				_value = this.refs[key].validate(function (value, formitem){
					if(formitem.props.required && !value){
						return false;
					}
				});
			}else if(this.refs[key].getValue){
				_value = this.refs[key].getValue();
			}
			if(!_value){
				return false;
			}else {
				_values[key] = _value;
			}
		}

		return _values;
	},
	submit: function (){
		var _values = this.getSubmitValue();
		if(_values){
			var _base = _values.base;
			_values.base = null;
			delete _values.base;
			zn.preloader.open({ title: '正在创建中...' });
			//zn.debug('data: ', _base, _values);
			zn.http.post('/zn.plugin.workflow/wfindex/createInstance', {
				indexId: this.state.indexId,
				base: _base,
				data: _values
			}).then(function (data){
				if(data.status == 200){
					zn.notification.success('流程创建成功');
					var _result = this.props.onCreateSuccess && this.props.onCreateSuccess(data.result);
					if(!this.props.onCreateSuccess || _result !== false){
						zn.react.session.relativeJump('/znpluginworkflow.wfinstance?instanceId=' + data.result.instance_id);
					}
				}else {
					zn.notification.error('流程创建失败：' + data.result);
				}
				zn.preloader.close();
			}.bind(this), function (){
				var _result = this.props.onCreateError && this.props.onCreateError(data.result);
				if(_result !== false){
					zn.notification.error('流程创建失败：调用服务器错误');
					zn.preloader.close();
				}
			});
		}else {
			zn.notification.error('表单数据验证失败');
		}
	},
	__onPrimaryFormChange: function (value, input, form){
		this.props.onPrimaryFormChange && this.props.onPrimaryFormChange(value, input, form);
	},
	render: function(){
		if(!this.state.indexId){
			return <zn.react.DataLoader style={{padding: 20}} loader="timer" content="正在加载中..." />;
		}
		return (
			<div className={zn.react.classname("zn-plugin-workflow-create-instance", this.props.className)} style={this.props.style} >
				<zn.react.Group title="表单信息" >
					{
						this.state.primaryTable && <zn.react.Form onChange={this.__onPrimaryFormChange} value={this.props.baseValue||{}} ref={this.state.primaryTable.table_name} buttons={[]} items={this.state.primaryTable.fields}/>
					}
					{
						this.state.deputyTables.map(function (deputy, index){
							deputy.width = null;
							delete deputy.width;
							return <DeputyTable {...this.props} onValidate={this.props.onDeputyValidate} deputy={deputy} ref={deputy.table_name} />;
						}.bind(this))
					}
				</zn.react.Group>
				<zn.react.Group title="流程信息" >
					<zn.react.Form ref="base" buttons={[]} items={this.state.baseFormItems}/>
				</zn.react.Group>
				<div style={{paddingTop: 10, overflow: 'hidden'}}>
					<zn.react.Button onClick={this.submit} float="right" text="创建流程单据" icon="fa-plus" style={{width: 120}} />
				</div>
			</div>
		);
	}
});
