require('./FlowStep.less');
var React = require('react');

module.exports = React.createClass({
	__renderSchemaFormData: function (data){
		console.log(data);
		if(data){
			var _data = JSON.parse(data);
			return <zn.react.Group title="自定义表单" className="schema-form-data" >
				<ul>
					{
						Object.keys(_data).map(function (key){
							return <li className="item">
								<div className="key">{key}</div>
								<div className="value">{_data[key]}</div>
							</li>;
						})
					}
				</ul>
			</zn.react.Group>;
		}else {
			return null;
		}
	},
	__onRemark: function (value, index){
		zn.dialog({
			title: '添加备注',
			content: <zn.react.Form
				action='/zn.plugin.workflow/wfinstance/remark'
				exts={{ instance_id: this.props.instanceId, instance_step_id: index }}
				onSubmitSuccess={this.props.onRemarkSuccess}
				items={[
					{ title: '备注', name: 'content', type: 'Textarea' },
					{ title: '附件', name: 'attachments', type: 'FileUploader' }
				]} />
		});
	},
	render: function(){
		return (
			<div className="zn-plugin-workflow-instance-flow-step zn-plugin-workflow-panel" >
				<div className="title">
					<span>当前状态：{this.props.current.zn_title}</span>
				</div>
				<div className="content">
					<ul className="steps">
						{
							this.props.data.map(function (value, index){
								if(value.type=='end'){
									value.state = 2;
								}
								return <li className={"step state-" + value.state + ' type-' + value.type}>
									<div className="title">{value.zn_title}</div>
									<div className="dot">
										{
											!!(value.state==1) ? <i data-tooltip="添加备注" style={{ cursor: 'pointer' }} onClick={()=>this.__onRemark(value, index)} className='fa fa-pencil-square-o' /> : <i className="fa fa-check" />
										}
									</div>
									<div className="detail">
										<div className="user">{value.zn_modify_user || '☆☆☆'}</div>
										<div className="time">{value.zn_modify_time || value.zn_create_time}</div>
									</div>
								</li>;
							}.bind(this))
						}
					</ul>
					<ul className="steps-detail">
						{
							this.props.data.map(function (value){
								if(value.state==1 || value.type == 'end'){
									return null;
								}

								return <li className={"step state-" + value.state + ' type-' + value.type}>
									<div className="step-header">
										<span>[ {value.zn_modify_user} ] {value.zn_title}</span>
										<span>{value.zn_modify_time || value.zn_create_time}</span>
									</div>
									<div className="step-content">
										{this.__renderSchemaFormData(value.schema_form_data)}
										<div className="note">{value.zn_note}</div>
										<div className="files">
											<div className="title">附件：</div>
											<zn.react.Files value={value.files} />
										</div>
									</div>
								</li>;
							}.bind(this))
						}
					</ul>
					<zn.react.Group title="备注记录">
						<ul className="remarks">
							{
								this.props.current.remarks.map(function (value){
									return <li className="remark">
										<div className="remark-header">
											<span>{value.zn_create_user_convert}</span>
											<span>{value.zn_create_time}</span>
										</div>
										<div className="remark-content">
											<div className="note">{value.content}</div>
											<zn.react.Files value={value.attachments} />
										</div>
									</li>;
								}.bind(this))
							}
						</ul>
					</zn.react.Group>
				</div>
			</div>
		);
	}
});
