var React = require('react');
var WFSchemaDesigner = require('../component/WFSchemaDesigner.js');
var WFFormDesigner = require('../component/WFFormDesigner.js');

var WFIndexDesigner = React.createClass({
	getInitialState: function (){
		return {
			currIndex: 0
		};
	},
	render: function (){
		return (
			<div className="zr-flex-layout">
				<zn.react.ListView
					className="layout-header zr-tab-ios"
					style={{margin: 5}}
					selectMode="radio"
					textKey="text"
					valueKey="index"
					onClick={(value)=>this.setState({ currIndex: value.item.index })}
					value={this.state.currIndex}
					data={[
						{ index: 0, text: '流程定义', icon: 'fa-sitemap' },
						{ index: 1, text: '表单定义', icon: 'fa-server' }
					]} />
				<div className="layout-body">
					{
						this.state.currIndex?<WFFormDesigner indexId={this.props.indexId} />:<WFSchemaDesigner indexId={this.props.indexId} />
					}
				</div>
			</div>
		);
	}
});

module.exports = React.createClass({
	getDefaultProps: function () {
		return {
			model: 'zn_plugin_workflow_index',
			pid: 0,
			title: '流程索引',
			menuId: 0,
			fields: [
				{ title: '名称', type: 'Input', name: 'zn_title' },
				{ title: '类型', type: 'Radio', name: 'schema_type', value: 'category',
					data: [
						{ text: '流程类别', value: 'category' },
						{ text: '流程定义', value: 'schema' }
					]
				},
				{ title: '图标', type: 'RichSelector', selector: zn.plugin.admin.FontAwesomeIcons, textRender: (text)=>{ return <i className={"fa " + text} />;}, name: 'icon' },
				{ title: '是否启用权限', type: 'Radio', name: 'zn_rights_enabled', value: 0,
					data: [
						{ text: '禁止', value: 0 },
						{ text: '启用', value: 1 }
					]
				},
				{ title: '权限用户', type: zn.plugin.admin.UserSelector, mulitable: true, name: 'zn_rights_users' },
				{ title: '权限角色', type: zn.plugin.admin.RoleSelector, name: 'zn_rights_roles' },
				{ title: '说明', type: 'Textarea', name: 'zn_note' }
			]
		};
	},
	__rightRender: function (data){
		if(data.data.schema_type=='category'){
			return;
		}

		return <WFIndexDesigner indexId={data.value} />;
	},
	__itemContentRender: function (data, treeColumn, tree){
		return <span>
			{data.schema_type=='category'?<i data-tooltip="流程类别" className='fa fa-folder' style={{padding: 5}} />:<i title="流程定义" className={'fa '+(data.icon||'fa-sitemap')} style={{padding: 5}} style={{padding: 5}} />}
			{data.zn_title}
		</span>;
	},
	render:function(){
		return (
			<zn.plugin.admin.TreeModelView {...this.props} rightRender={this.__rightRender} itemContentRender={this.__itemContentRender} />
		);
	}
});
